<script setup lang="ts">
import { ref, reactive, computed } from "vue"
import type { Ref, ComputedRef } from "vue"
import axios from "axios"

export type User = {
    // ...
};

type State = {
    username: string;
    password: string;
    isLoading: boolean;
    errorMessage: string;
    user: User | null;
};

type RolePill = {
    id: number;
    name: string;
    backgroundColor: '#ef4444' | "#8b5cf6" | "#3b82f6"
};

const state = reactive({
    username: "",
    password: "",
    isLoading: false,
    errorMessage: "There was an error",
    user: null
} as State)


const dialog: Ref<null | HTMLDialogElement> = ref(null)

const rolePills: ComputedRef<RolePill[]> = computed(() => {
    return state.user.roles
})

const login = () => {
    state.isLoading = true
    // ...
    state.isLoading = false
}
</script>

<template>
    <div class="page-wrapper">
        <div v-if="!state.user" class="login-card">
            <h1>Top Secret Login Page</h1>
            <hr />
            <div class="input-layout">
                <label>Username
                    <input type="text" v-model="state.username" />
                </label>
                <label>Password
                    <input type="password" v-model="state.password" />
                </label>
                <button @click="login">
                    {{ state.isLoading ? "...loading" : "Login" }}
                </button>
            </div>
        </div>
        <div v-else class="login-card flex-layout columns">
            <img :src="state.user.imgUri" />
            <div class="flex-layout">
                <h1>{{ state.user.name }}</h1>
                <p>{{ state.user.tagline }}</p>
            </div>
            <div class="flex-layout">
                <span v-for="role in rolePills" :key="role.id" class="role-pill" :style="`background-color: ${role.backgroundColor}`">
                    {{ role.name }}
                </span>
            </div>
            <blockquote>
                {{ state.user.bio }}
            </blockquote>
            <button @click="state.user = null">
                Logout
            </button>
        </div>
        <dialog ref="dialog">
            <div class="flex-layout">
                <span class="error-ball">!</span>
                <p>{{ state.errorMessage }}</p>
            </div>
            <div class="close-wrapper">
                <button @click="dialog?.close()" class="secondary">
                    Close
                </button>
            </div>
        </dialog>
    </div>
</template>

<style scoped>

</style>
